Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 54)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 54)
@@ -0,0 +1,604 @@
+
+#include "TComUpsampleFilter.h"
+#include "TypeDef.h"
+
+#if SVC_UPSAMPLING
+// ====================================================================================================================
+// Tables:
+// 1. PHASE_DERIVATION_IN_INTEGER = 0 is the implementation using 2 multi-phase (12 phase and 8 phase) filter sets 
+//    by following K0378.
+// 2. PHASE_DERIVATION_IN_INTEGER = 1 is the implemetation using a 16-phase filter set just for speed up. Some phases 
+//    is approximated to x/16 (e.g. 1/3 -> 5/16). 
+// 3. It was confirmed that two implementations provides the identical result. 
+// 4. By default, PHASE_DERIVATION_IN_INTEGER is set to 1. 
+// ====================================================================================================================
+#define CNU -1 ///< Coefficients Not Used
+
+#if PHASE_DERIVATION_IN_INTEGER
+const Int TComUpsampleFilter::m_lumaFixedFilter[16][NTAPS_US_LUMA] =
+{
+  {  0,  0,  0, 64,  0,  0,  0,  0}, //
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, //
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, //
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, //
+  { -1, 4, -11, 52, 26,  -8, 3, -1}, // <-> actual phase shift 1/3, used for spatial scalability x1.5      
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, //       
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  { -1, 4, -11, 40, 40, -11, 4, -1}, // <-> actual phase shift 1/2, equal to HEVC MC, used for spatial scalability x2
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  { -1, 3,  -8, 26, 52, -11, 4, -1}, // <-> actual phase shift 2/3, used for spatial scalability x1.5
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}, // 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU}  // 
+};
+
+const Int TComUpsampleFilter::m_chromaFixedFilter[16][NTAPS_US_CHROMA] =
+{
+#if CHROMA_UPSAMPLING
+  {  0, 64,  0,  0},//
+  {CNU,CNU,CNU,CNU},//
+  {CNU,CNU,CNU,CNU},//
+  {CNU,CNU,CNU,CNU},// 
+  { -4, 54, 16, -2},// <-> actual phase shift 1/4,equal to HEVC MC, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+  { -6, 52, 20, -2},// <-> actual phase shift 1/3, used for spatial scalability x1.5   
+  { -6, 46, 28, -4},// <-> actual phase shift 3/8,equal to HEVC MC, used for spatial scalability x2 (only for accurate Chroma alignement)      
+  {CNU,CNU,CNU,CNU},// 
+  { -4, 36, 36, -4},// <-> actual phase shift 1/2,equal to HEVC MC, used for spatial scalability x2
+  { -4, 30, 42, -4},// <-> actual phase shift 7/12, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+  {CNU,CNU,CNU,CNU},// 
+  { -2, 20, 52, -6},// <-> actual phase shift 2/3, used for spatial scalability x1.5
+  {CNU,CNU,CNU,CNU},// 
+  {CNU,CNU,CNU,CNU},// 
+  { -2, 10, 58, -2},// <-> actual phase shift 7/8,equal to HEVC MC, used for spatial scalability x2 (only for accurate Chroma alignement)  
+  {  0,  4, 62, -2} // <-> actual phase shift 11/12, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+#else
+  {  0, 64,  0,  0},//
+  {CNU,CNU,CNU,CNU},//
+  {CNU,CNU,CNU,CNU},//
+  {CNU,CNU,CNU,CNU},// 
+  { -4, 54, 16, -2},// <-> actual phase shift 1/4,equal to HEVC MC, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+  { -5, 50, 22, -3},// <-> actual phase shift 1/3, used for spatial scalability x1.5   
+  { -6, 46, 28, -4},// <-> actual phase shift 3/8,equal to HEVC MC, used for spatial scalability x2 (only for accurate Chroma alignement)      
+  {CNU,CNU,CNU,CNU},// 
+  { -4, 36, 36, -4},// <-> actual phase shift 1/2,equal to HEVC MC, used for spatial scalability x2
+  { -4, 30, 43, -5},// <-> actual phase shift 7/12, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+  {CNU,CNU,CNU,CNU},// 
+  { -3, 22, 50, -5},// <-> actual phase shift 2/3, used for spatial scalability x1.5
+  {CNU,CNU,CNU,CNU},// 
+  {CNU,CNU,CNU,CNU},// 
+  { -2, 10, 58, -2},// <-> actual phase shift 7/8,equal to HEVC MC, used for spatial scalability x2 (only for accurate Chroma alignement)  
+  { -1,  5, 62, -2} // <-> actual phase shift 11/12, used for spatial scalability x1.5 (only for accurate Chroma alignement)
+#endif
+};
+#else
+const Int TComUpsampleFilter::m_lumaFixedFilter[12][NTAPS_US_LUMA] =
+{
+  { 0,  0,   0, 64,  0,   0, 0,  0},
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//1/12 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//2/12 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//3/12 
+  { -1, 4, -11, 52, 26,  -8, 3, -1},//4/12 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//5/12 
+  { -1, 4, -11, 40, 40, -11, 4, -1},//6/12       
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//7/12 
+  { -1, 3,  -8, 26, 52, -11, 4, -1},//8/12 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//9/12 
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//10/12
+  {CNU,CNU,CNU,CNU,CNU,CNU,CNU,CNU},//11/12
+};
+
+const Int TComUpsampleFilter::m_chromaFixedFilter15[12][NTAPS_US_CHROMA] =
+{
+  {  0, 64,  0,  0},
+  {CNU,CNU,CNU,CNU},//1/12 
+  {CNU,CNU,CNU,CNU},//2/12 
+  { -4, 54, 16, -2},//3/12 
+  { -5, 50, 22, -3},//4/12 
+  {CNU,CNU,CNU,CNU},//5/12 
+  {CNU,CNU,CNU,CNU},//6/12 
+  { -4, 30, 43, -5},//7/12 
+  { -3, 22, 50, -5},//8/12 
+  {CNU,CNU,CNU,CNU},//9/12 
+  {CNU,CNU,CNU,CNU},//10/12
+  { -1,  5, 62, -2} //11/12
+};
+
+const Int TComUpsampleFilter::m_chromaFixedFilter20[8][NTAPS_US_CHROMA] =
+{
+  {  0, 64,  0,  0},
+  {CNU,CNU,CNU,CNU},//1/8 
+  {CNU,CNU,CNU,CNU},//2/8 
+  { -6, 46, 28, -4},//3/8 
+  { -4, 36, 36, -4},//4/8 
+  {CNU,CNU,CNU,CNU},//5/8 
+  {CNU,CNU,CNU,CNU},//6/8 
+  { -2, 10, 58, -2},//7/8 
+};
+#endif
+
+TComUpsampleFilter::TComUpsampleFilter(void)
+{
+}
+
+TComUpsampleFilter::~TComUpsampleFilter(void)
+{
+}
+
+Void TComUpsampleFilter::upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic )
+{
+  assert ( NTAPS_US_LUMA == 8 );
+  assert ( NTAPS_US_CHROMA == 4 );
+
+  Int i, j;
+
+  //========== Y component upsampling ===========
+  const Window &confBL = pcBasePic->getConformanceWindow();
+  const Window &confEL = pcUsPic->getConformanceWindow();
+
+  Int iBWidth   = pcBasePic->getWidth () - confBL.getWindowLeftOffset() - confBL.getWindowRightOffset();
+  Int iBHeight  = pcBasePic->getHeight() - confBL.getWindowTopOffset() - confBL.getWindowBottomOffset();
+  Int iBStride  = pcBasePic->getStride();
+
+  Int iEWidth   = pcUsPic->getWidth () - confEL.getWindowLeftOffset() - confEL.getWindowRightOffset();
+  Int iEHeight  = pcUsPic->getHeight() - confEL.getWindowTopOffset() - confEL.getWindowBottomOffset();
+  Int iEStride  = pcUsPic->getStride();
+  
+  Pel* piTempBufY = pcTempPic->getLumaAddr();
+  Pel* piSrcBufY  = pcBasePic->getLumaAddr();
+  Pel* piDstBufY  = pcUsPic->getLumaAddr();
+  
+  Pel* piSrcY;
+  Pel* piDstY;
+  
+  Pel* piTempBufU = pcTempPic->getCbAddr();
+  Pel* piSrcBufU  = pcBasePic->getCbAddr();
+  Pel* piDstBufU  = pcUsPic->getCbAddr();
+  
+  Pel* piTempBufV = pcTempPic->getCrAddr();
+  Pel* piSrcBufV  = pcBasePic->getCrAddr();
+  Pel* piDstBufV  = pcUsPic->getCrAddr();
+  
+  Pel* piSrcU;
+  Pel* piDstU;
+  Pel* piSrcV;
+  Pel* piDstV;
+  
+#if JCTVC_L0178
+  Pel *tempBufRight = NULL, *tempBufBottom = NULL;
+  Int tempBufSizeRight = 0, tempBufSizeBottom = 0;
+  
+  if ( pcBasePic->getPicCropRightOffset() )
+  {
+    tempBufSizeRight = pcBasePic->getPicCropRightOffset() * pcBasePic->getHeight();
+  }
+  
+  if( pcBasePic->getPicCropBottomOffset() )
+  {
+    tempBufSizeBottom = pcBasePic->getPicCropBottomOffset() * pcBasePic->getWidth ();
+  }
+  
+  if( tempBufSizeRight )
+  {
+    tempBufRight = (Pel *) xMalloc(Pel, tempBufSizeRight + (tempBufSizeRight>>1) );
+    assert( tempBufRight );
+  }
+  
+  if( tempBufSizeBottom )
+  {
+    tempBufBottom = (Pel *) xMalloc(Pel, tempBufSizeBottom + (tempBufSizeBottom>>1) );
+    assert( tempBufBottom );
+  }
+ 
+#endif
+  
+#if PHASE_DERIVATION_IN_INTEGER
+  Int iRefPos16 = 0;
+  Int phase    = 0;
+  Int refPos   = 0; 
+  Int* coeff = m_chromaFilter[phase];
+  for ( i = 0; i < 16; i++)
+  {
+    memcpy(   m_lumaFilter[i],   m_lumaFixedFilter[i], sizeof(Int) * NTAPS_US_LUMA   );
+    memcpy( m_chromaFilter[i], m_chromaFixedFilter[i], sizeof(Int) * NTAPS_US_CHROMA );
+  }
+#else
+  for ( i = 0; i < 12; i++)
+  {
+    memcpy( m_lumaFilter[i], m_lumaFixedFilter[i], sizeof(Int) * NTAPS_US_LUMA );
+  }
+
+  Int chromaPhaseDenominator;
+  if (iEWidth == 2*iBWidth) // 2x scalability
+  {
+    for ( i = 0; i < 8; i++)
+    {
+      memcpy( m_chromaFilter[i], m_chromaFixedFilter20[i], sizeof(Int) * NTAPS_US_CHROMA );
+    }
+    chromaPhaseDenominator = 8;
+  }
+  else
+  {
+    for ( i = 0; i < 12; i++) // 1.5x scalability
+    {
+      memcpy( m_chromaFilter[i], m_chromaFixedFilter15[i], sizeof(Int) * NTAPS_US_CHROMA );
+    }
+    chromaPhaseDenominator = 12;
+  }
+#endif
+
+  assert ( iEWidth == 2*iBWidth || 2*iEWidth == 3*iBWidth );
+  assert ( iEHeight == 2*iBHeight || 2*iEHeight == 3*iBHeight );
+
+#if JCTVC_L0178
+  // save the cropped region to copy back to the base picture since the base picture might be used as a reference picture
+  if( tempBufSizeRight )
+  {
+    piSrcY = piSrcBufY + iBWidth;
+    piDstY = tempBufRight;
+    for( i = 0; i < pcBasePic->getHeight(); i++ )
+    {
+      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getPicCropRightOffset());
+      piSrcY += iBStride;
+      piDstY += pcBasePic->getPicCropRightOffset();
+    }
+    
+    if(pcBasePic->getPicCropRightOffset()>>1)
+    {
+      Int iBStrideChroma = (iBStride>>1);
+      piSrcU = piSrcBufU + (iBWidth>>1);
+      piDstU = tempBufRight + pcBasePic->getPicCropRightOffset() * pcBasePic->getHeight();
+      piSrcV = piSrcBufV + (iBWidth>>1);
+      piDstV = piDstU + (pcBasePic->getPicCropRightOffset()>>1) * (pcBasePic->getHeight()>>1);
+    
+      for( i = 0; i < pcBasePic->getHeight()>>1; i++ )
+      {
+        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getPicCropRightOffset()>>1));
+        piSrcU += iBStrideChroma;
+        piDstU += (pcBasePic->getPicCropRightOffset()>>1);
+        
+        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getPicCropRightOffset()>>1));
+        piSrcV += iBStrideChroma;
+        piDstV += (pcBasePic->getPicCropRightOffset()>>1);
+      }
+    }
+    
+    pcBasePic->setWidth(iBWidth);
+  }
+  
+  if( tempBufSizeBottom )
+  {
+    piSrcY = piSrcBufY + iBHeight * iBStride;
+    piDstY = tempBufBottom;
+    for( i = 0; i < pcBasePic->getPicCropBottomOffset(); i++ )
+    {
+      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getWidth());
+      piSrcY += iBStride;
+      piDstY += pcBasePic->getWidth();
+    }
+    
+    if(pcBasePic->getPicCropBottomOffset()>>1)
+    {
+      Int iBStrideChroma = (iBStride>>1);
+      piSrcU = piSrcBufU + (iBHeight>>1) * iBStrideChroma;
+      piDstU = tempBufBottom + pcBasePic->getPicCropBottomOffset() * pcBasePic->getWidth();
+      piSrcV = piSrcBufV + (iBHeight>>1) * iBStrideChroma;
+      piDstV = piDstU + (pcBasePic->getPicCropBottomOffset()>>1) * (pcBasePic->getWidth()>>1);
+      
+      for( i = 0; i < pcBasePic->getPicCropBottomOffset()>>1; i++ )
+      {
+        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getWidth()>>1));
+        piSrcU += iBStrideChroma;
+        piDstU += (pcBasePic->getWidth()>>1);
+        
+        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getWidth()>>1));
+        piSrcV += iBStrideChroma;
+        piDstV += (pcBasePic->getWidth()>>1);
+      }
+    }
+
+    pcBasePic->setHeight(iBHeight);
+  }
+#endif
+  
+  pcBasePic->setBorderExtension(false);
+  pcBasePic->extendPicBorder   (); // extend the border.
+
+#if PHASE_DERIVATION_IN_INTEGER
+  Int   iShiftX = 16;
+  Int   iShiftY = 16;
+
+  Int   iPhaseX = 0;
+  Int   iPhaseY = 0;
+
+  Int   iAddX       = ( ( ( iBWidth * iPhaseX ) << ( iShiftX - 2 ) ) + ( iEWidth >> 1 ) ) / iEWidth + ( 1 << ( iShiftX - 5 ) );
+  Int   iAddY       = ( ( ( iBHeight * iPhaseY ) << ( iShiftY - 2 ) ) + ( iEHeight >> 1 ) ) / iEHeight+ ( 1 << ( iShiftY - 5 ) );
+
+  Int   iDeltaX     = 4 * iPhaseX;
+  Int   iDeltaY     = 4 * iPhaseY;  
+
+
+  Int iShiftXM4 = iShiftX - 4;
+  Int iShiftYM4 = iShiftY - 4;
+
+  Int   iScaleX     = ( ( iBWidth << iShiftX ) + ( iEWidth >> 1 ) ) / iEWidth;
+  Int   iScaleY     = ( ( iBHeight << iShiftY ) + ( iEHeight >> 1 ) ) / iEHeight;
+#else
+  const Double sFactor = 1.0 * iBWidth / iEWidth;
+  const Double sFactor12 = sFactor * 12;
+#endif
+
+  //========== horizontal upsampling ===========
+  for( i = 0; i < iEWidth; i++ )
+  {
+#if PHASE_DERIVATION_IN_INTEGER
+    iRefPos16 = ((i*iScaleX + iAddX) >> iShiftXM4) - iDeltaX;
+    phase    = iRefPos16 & 15;
+    refPos   = iRefPos16 >> 4;
+    coeff = m_lumaFilter[phase];
+#else
+    Int refPos12 = (Int) ( i * sFactor12 );
+    Int refPos = (Int)( i * sFactor );
+    Int phase = (refPos12 + 12) % 12; 
+    Int* coeff = m_lumaFilter[phase];
+#endif
+
+    piSrcY = piSrcBufY + refPos -((NTAPS_US_LUMA>>1) - 1);
+    piDstY = piTempBufY + i;
+
+    for( j = 0; j < iBHeight ; j++ )
+    {
+      *piDstY = sumLumaHor(piSrcY, coeff);
+      piSrcY += iBStride;
+      piDstY += iEStride;
+    }
+  }
+
+
+  //========== vertical upsampling ===========
+  pcTempPic->setBorderExtension(false);
+  pcTempPic->setHeight(iBHeight);
+  pcTempPic->extendPicBorder   (); // extend the border.
+  pcTempPic->setHeight(iEHeight);
+
+  const Int nShift = US_FILTER_PREC*2;
+  Int iOffset = 1 << (nShift - 1); 
+
+  for( j = 0; j < iEHeight; j++ )
+  {
+#if PHASE_DERIVATION_IN_INTEGER
+    iRefPos16 = ((j*iScaleY + iAddY) >> iShiftYM4) - iDeltaY;
+    phase    = iRefPos16 & 15;
+    refPos   = iRefPos16 >> 4;
+    coeff = m_lumaFilter[phase];
+#else
+    Int refPos12 = (Int) (j * sFactor12 );
+    Int refPos = (Int)( j * sFactor );
+    Int phase = (refPos12 + 12) % 12;
+    Int* coeff = m_lumaFilter[phase];
+#endif
+
+    piSrcY = piTempBufY + (refPos -((NTAPS_US_LUMA>>1) - 1))*iEStride;
+    piDstY = piDstBufY + j * iEStride;
+
+    for( i = 0; i < iEWidth; i++ )
+    {
+      *piDstY = ClipY( (sumLumaVer(piSrcY, coeff, iEStride) + iOffset) >> (nShift));
+      piSrcY++;
+      piDstY++;
+    }
+  }
+
+  //========== UV component upsampling ===========
+
+  iEWidth  >>= 1;
+  iEHeight >>= 1;
+
+  iBWidth  >>= 1;
+  iBHeight >>= 1;
+
+  iBStride  = pcBasePic->getCStride();
+  iEStride  = pcUsPic->getCStride();
+
+#if PHASE_DERIVATION_IN_INTEGER
+  iShiftX = 16;
+  iShiftY = 16;
+
+  iPhaseX = 0;
+  iPhaseY = 1;
+
+  iAddX       = ( ( ( iBWidth * iPhaseX ) << ( iShiftX - 2 ) ) + ( iEWidth >> 1 ) ) / iEWidth + ( 1 << ( iShiftX - 5 ) );
+  iAddY       = ( ( ( iBHeight * iPhaseY ) << ( iShiftY - 2 ) ) + ( iEHeight >> 1 ) ) / iEHeight+ ( 1 << ( iShiftY - 5 ) );
+
+  iDeltaX     = 4 * iPhaseX;
+  iDeltaY     = 4 * iPhaseY;
+
+  iShiftXM4 = iShiftX - 4;
+  iShiftYM4 = iShiftY - 4;
+
+  iScaleX     = ( ( iBWidth << iShiftX ) + ( iEWidth >> 1 ) ) / iEWidth;
+  iScaleY     = ( ( iBHeight << iShiftY ) + ( iEHeight >> 1 ) ) / iEHeight;
+#endif
+
+  //========== horizontal upsampling ===========
+  for( i = 0; i < iEWidth; i++ )
+  {
+#if PHASE_DERIVATION_IN_INTEGER
+    iRefPos16 = ((i*iScaleX + iAddX) >> iShiftXM4) - iDeltaX;
+    phase    = iRefPos16 & 15;
+    refPos   = iRefPos16 >> 4;
+    coeff = m_chromaFilter[phase];
+#else
+    Int refPosM = (Int) ( i * chromaPhaseDenominator * sFactor );
+    Int refPos = (Int)( i * sFactor );
+    Int phase = (refPosM + chromaPhaseDenominator) % chromaPhaseDenominator;
+    Int* coeff = m_chromaFilter[phase];
+#endif
+
+    piSrcU = piSrcBufU + refPos -((NTAPS_US_CHROMA>>1) - 1);
+    piSrcV = piSrcBufV + refPos -((NTAPS_US_CHROMA>>1) - 1);
+    piDstU = piTempBufU + i;
+    piDstV = piTempBufV + i;
+
+    for( j = 0; j < iBHeight ; j++ )
+    {
+      *piDstU = sumChromaHor(piSrcU, coeff);
+      *piDstV = sumChromaHor(piSrcV, coeff);
+
+      piSrcU += iBStride;
+      piSrcV += iBStride;
+      piDstU += iEStride;
+      piDstV += iEStride;
+    }
+  }
+
+  //========== vertical upsampling ===========
+  pcTempPic->setBorderExtension(false);
+  pcTempPic->setHeight(iBHeight << 1);
+  pcTempPic->extendPicBorder   (); // extend the border.
+  pcTempPic->setHeight(iEHeight << 1);
+
+  for( j = 0; j < iEHeight; j++ )
+  {
+#if PHASE_DERIVATION_IN_INTEGER
+    iRefPos16 = ((j*iScaleY + iAddY) >> iShiftYM4) - iDeltaY;
+    phase    = iRefPos16 & 15;
+    refPos   = iRefPos16 >> 4; 
+    coeff = m_chromaFilter[phase];
+#else
+    Int refPosM = (Int) (j * chromaPhaseDenominator * sFactor) - 1;
+    Int refPos; 
+    if ( refPosM < 0 )
+    {
+      refPos = (Int)( j * sFactor ) - 1;
+    }
+    else
+    {
+      refPos = refPosM / chromaPhaseDenominator;
+    }
+    Int phase = (refPosM + chromaPhaseDenominator) % chromaPhaseDenominator;
+    Int* coeff = m_chromaFilter[phase];
+#endif
+
+    piSrcU = piTempBufU  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*iEStride;
+    piSrcV = piTempBufV  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*iEStride;
+
+    piDstU = piDstBufU + j*iEStride;
+    piDstV = piDstBufV + j*iEStride;
+
+    for( i = 0; i < iEWidth; i++ )
+    {
+      *piDstU = ClipC( (sumChromaVer(piSrcU, coeff, iEStride) + iOffset) >> (nShift));
+      *piDstV = ClipC( (sumChromaVer(piSrcV, coeff, iEStride) + iOffset) >> (nShift));
+
+      piSrcU++;
+      piSrcV++;
+      piDstU++;
+      piDstV++;
+    }
+  }
+
+  pcUsPic->setBorderExtension(false);
+  pcUsPic->extendPicBorder   (); // extend the border.
+
+  //Reset the Border extension flag
+  pcUsPic->setBorderExtension(false);
+  pcTempPic->setBorderExtension(false);
+  pcBasePic->setBorderExtension(false);
+  
+#if JCTVC_L0178
+  // copy back the saved cropped region
+  if( tempBufSizeRight )
+  {
+    // put the correct width back
+    pcBasePic->setWidth(pcBasePic->getWidth()+pcBasePic->getPicCropRightOffset());
+  }
+  if( tempBufSizeBottom )
+  {
+    pcBasePic->setHeight(pcBasePic->getHeight()+pcBasePic->getPicCropBottomOffset());
+  }
+  
+  iBWidth   = pcBasePic->getWidth () - pcBasePic->getPicCropLeftOffset() - pcBasePic->getPicCropRightOffset();
+  iBHeight  = pcBasePic->getHeight() - pcBasePic->getPicCropTopOffset() - pcBasePic->getPicCropBottomOffset();
+  
+  iBStride  = pcBasePic->getStride();
+  
+  if( tempBufSizeRight )
+  {
+    piSrcY = tempBufRight;
+    piDstY = piSrcBufY + iBWidth;
+    
+    for( i = 0; i < pcBasePic->getHeight(); i++ )
+    {
+      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getPicCropRightOffset());
+      piSrcY += pcBasePic->getPicCropRightOffset();
+      piDstY += iBStride;
+    }
+    
+    if(pcBasePic->getPicCropRightOffset()>>1)
+    {
+      Int iBStrideChroma = (iBStride>>1);
+      piSrcU = tempBufRight + pcBasePic->getPicCropRightOffset() * pcBasePic->getHeight();
+      piDstU = piSrcBufU + (iBWidth>>1);
+      piSrcV = piSrcU + (pcBasePic->getPicCropRightOffset()>>1) * (pcBasePic->getHeight()>>1);
+      piDstV = piSrcBufV + (iBWidth>>1);
+
+      for( i = 0; i < pcBasePic->getHeight()>>1; i++ )
+      {
+        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getPicCropRightOffset()>>1));
+        piSrcU += (pcBasePic->getPicCropRightOffset()>>1);
+        piDstU += iBStrideChroma;
+        
+        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getPicCropRightOffset()>>1));
+        piSrcV += (pcBasePic->getPicCropRightOffset()>>1);
+        piDstV += iBStrideChroma;
+      }
+    }
+  }
+  
+  if( tempBufSizeBottom )
+  {
+    piDstY = piSrcBufY + iBHeight * iBStride;
+    piSrcY = tempBufBottom;
+    for( i = 0; i < pcBasePic->getPicCropBottomOffset(); i++ )
+    {
+      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getWidth());
+      piDstY += iBStride;
+      piSrcY += pcBasePic->getWidth();
+    }
+    
+    if(pcBasePic->getPicCropBottomOffset()>>1)
+    {
+      Int iBStrideChroma = (iBStride>>1);
+      piSrcU = tempBufBottom + pcBasePic->getPicCropBottomOffset() * pcBasePic->getWidth();
+      piDstU = piSrcBufU + (iBHeight>>1) * iBStrideChroma;
+      piSrcV = piSrcU + (pcBasePic->getPicCropBottomOffset()>>1) * (pcBasePic->getWidth()>>1);
+      piDstV = piSrcBufV + (iBHeight>>1) * iBStrideChroma;
+            
+      for( i = 0; i < pcBasePic->getPicCropBottomOffset()>>1; i++ )
+      {
+        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getWidth()>>1));
+        piSrcU += (pcBasePic->getWidth()>>1);
+        piDstU += iBStrideChroma;
+        
+        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getWidth()>>1));
+        piSrcV += (pcBasePic->getWidth()>>1);
+        piDstV += iBStrideChroma;
+      }
+    }
+  
+  }
+
+  if( tempBufSizeRight )
+  {
+    xFree( tempBufRight );
+  }
+  if( tempBufSizeBottom )
+  {
+    xFree( tempBufBottom );
+  }
+#endif
+}
+#endif //SVC_EXTENSION
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 54)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 54)
@@ -0,0 +1,57 @@
+#ifndef __TCOMUPSAMPLEFILTER__
+#define __TCOMUPSAMPLEFILTER__
+
+#include "TComPic.h"
+#include "TComYuv.h"
+#include "TComDataCU.h"
+
+#define NTAPS_US_LUMA        8 ///< Number of taps for luma upsampling filter
+#define NTAPS_US_CHROMA      4 ///< Number of taps for chroma upsampling filter
+#define US_FILTER_PREC       6 ///< Log2 of sum of filter taps
+
+class TComUpsampleFilter
+{
+private:
+#if PHASE_DERIVATION_IN_INTEGER
+  static const Int m_lumaFixedFilter[16][NTAPS_US_LUMA];     ///< Luma filter taps for both 1.5x and 2x scalability
+  static const Int m_chromaFixedFilter[16][NTAPS_US_CHROMA]; ///< Chroma filter taps for 1.5x scalability
+
+  Int m_lumaFilter[16][NTAPS_US_LUMA];
+  Int m_chromaFilter[16][NTAPS_US_CHROMA];
+#else
+  static const Int m_lumaFixedFilter[12][NTAPS_US_LUMA];     ///< Luma filter taps for both 1.5x and 2x scalability
+  static const Int m_chromaFixedFilter20[8][NTAPS_US_CHROMA]; ///< Chroma filter taps for 2x scalability
+  static const Int m_chromaFixedFilter15[12][NTAPS_US_CHROMA]; ///< Chroma filter taps for 1.5x scalability
+
+  Int m_lumaFilter[12][NTAPS_US_LUMA];
+  Int m_chromaFilter[12][NTAPS_US_CHROMA];
+#endif
+
+  static inline Int sumLumaHor( Pel* pel, Int* coeff )
+  {
+    return ( pel[0]*coeff[0] + pel[1]*coeff[1] + pel[2]*coeff[2] + pel[3]*coeff[3] + pel[4]*coeff[4] + pel[5]*coeff[5] + pel[6]*coeff[6] + pel[7]*coeff[7]);
+  }
+
+  static inline Int sumChromaHor( Pel* pel, Int* coeff )
+  {
+    return ( pel[0]*coeff[0] + pel[1]*coeff[1] + pel[2]*coeff[2] + pel[3]*coeff[3] );
+  }
+
+  static inline Int sumLumaVer( Pel* pel, Int* coeff, Int stride )
+  {
+    return ( pel[0]*coeff[0] + pel[stride]*coeff[1] + pel[2*stride]*coeff[2] + pel[3*stride]*coeff[3] + pel[4*stride]*coeff[4] + pel[5*stride]*coeff[5] + pel[6*stride]*coeff[6] + pel[7*stride]*coeff[7]);
+  }
+
+  static inline Int sumChromaVer( Pel* pel, Int* coeff, Int stride )
+  {
+    return ( pel[0]*coeff[0] + pel[stride]*coeff[1] + pel[2*stride]*coeff[2] + pel[3*stride]*coeff[3] );
+  }
+
+public:
+  TComUpsampleFilter(void);
+  ~TComUpsampleFilter(void);
+
+ Void upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+};
+
+#endif //__TCOMUPSAMPLEFILTER__
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.cpp	(revision 54)
@@ -184,4 +184,57 @@
 }
 
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+Void TComYuv::copyFromPicLuma  ( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiZorderIdxInCU, UInt uiAbsZorderIdx, UInt uiWidth, UInt uiHeight )
+{
+  Int  y;
+
+  Pel* pDst     = getLumaAddr(uiAbsZorderIdx);
+  Pel* pSrc     = pcPicYuvSrc->getLumaAddr ( iCuAddr, uiZorderIdxInCU + uiAbsZorderIdx );
+
+  UInt  iDstStride  = getStride();
+  UInt  iSrcStride  = pcPicYuvSrc->getStride();
+  for ( y = uiHeight; y != 0; y-- )
+  {
+    ::memcpy( pDst, pSrc, sizeof(Pel)*uiWidth);
+    pDst += iDstStride;
+    pSrc += iSrcStride;
+  }
+}
+
+Void TComYuv::copyFromPicChroma( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiZorderIdxInCU, UInt uiAbsZorderIdx, UInt uiCWidth, UInt uiCHeight, UInt uiChromaId  )
+{
+  Int  y;
+
+  if (!uiChromaId)
+  {
+    Pel* pDstU      = getCbAddr(uiAbsZorderIdx); 
+    Pel* pSrcU      = pcPicYuvSrc->getCbAddr( iCuAddr, uiZorderIdxInCU + uiAbsZorderIdx );
+
+    UInt  iDstStride = getCStride();
+    UInt  iSrcStride = pcPicYuvSrc->getCStride();
+    for ( y = uiCHeight; y != 0; y-- )
+    {
+      ::memcpy( pDstU, pSrcU, sizeof(Pel)*(uiCWidth) );
+      pSrcU += iSrcStride;
+      pDstU += iDstStride;
+    }
+  }
+  else
+  {
+    Pel* pDstV      = getCrAddr(uiAbsZorderIdx);
+    Pel* pSrcV      = pcPicYuvSrc->getCrAddr( iCuAddr, uiZorderIdxInCU + uiAbsZorderIdx );
+
+    UInt  iDstStride = getCStride();
+    UInt  iSrcStride = pcPicYuvSrc->getCStride();
+    for ( y = uiCHeight; y != 0; y-- )
+    {
+      ::memcpy( pDstV, pSrcV, sizeof(Pel)*(uiCWidth) );
+      pSrcV += iSrcStride;
+      pDstV += iDstStride;
+    }
+  }
+}
+#endif
+
 Void TComYuv::copyToPartYuv( TComYuv* pcYuvDst, UInt uiDstPartIdx )
 {
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TComYuv.h	(revision 54)
@@ -115,4 +115,8 @@
   Void    copyFromPicLuma      ( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiAbsZorderIdx );
   Void    copyFromPicChroma    ( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiAbsZorderIdx );
+#if NO_RESIDUAL_FLAG_FOR_BLPRED
+  Void    copyFromPicLuma  ( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiZorderIdxInCU, UInt uiAbsZorderIdx, UInt uiWidth, UInt uiHeight );
+  Void    copyFromPicChroma( TComPicYuv* pcPicYuvSrc, UInt iCuAddr, UInt uiZorderIdxInCU, UInt uiAbsZorderIdx, UInt uiCWidth, UInt uiCHeight, UInt uiChromaId  );
+#endif
   
   //  Copy Small YUV buffer to the part of other Big YUV buffer
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibCommon/TypeDef.h	(revision 54)
@@ -38,4 +38,68 @@
 #ifndef _TYPEDEF__
 #define _TYPEDEF__
+
+#define SVC_EXTENSION                    1
+
+#define SYNTAX_BYTES                     10      ///< number of bytes taken by syntaxes per 4x4 block [RefIdxL0(1byte), RefIdxL1(1byte), MVxL0(2bytes), MVyL0(2bytes), MVxL1(2bytes), MVyL1(2bytes)]
+
+#if SVC_EXTENSION
+#define MAX_LAYERS                       2      ///< max number of layers the codec is supposed to handle
+
+#define SVC_COL_BLK                      1      ///< get co-located block
+#define SVC_UPSAMPLING                   1      ///< upsampling filters
+#define PHASE_DERIVATION_IN_INTEGER      1      ///< upsampling filters implementation using only integer arithmetic
+#define SET_SLICE_LAYER_ID               1      ///< set layerId to the slice
+#define BUGFIX_925                       1      ///< bug fix ticket #925
+#define ENCODER_BUGFIX                   1      ///< L0167: encoder bug fix for inter mode
+#define CHROMA_UPSAMPLING                1      ///< L0335: Chroma upsampling with 5 bits coefficients
+
+#define MV_SCALING_FIX                   1      ///< fixing the base layer MV scaling
+#define MV_SCALING_POS_FIX               1      ///< use center pixels to get co-located base layer block
+#define MFM_CLIPPING_FIX                 1      ///< set the right picture size for the clipping
+
+#define AVC_BASE                         0      ///< YUV BL reading for AVC base SVC
+#define REF_IDX_FRAMEWORK                0      ///< inter-layer reference framework
+
+#if AVC_BASE
+#define AVC_SYNTAX                       1      ///< Syntax reading for AVC base
+#endif
+
+#if REF_IDX_FRAMEWORK
+#define REF_IDX_ME_AROUND_ZEROMV         0      ///< added ME around zero MV for inter-layer reference picture
+#define REF_IDX_ME_ZEROMV                1      ///< L0051: use zero motion for inter-layer reference picture (without fractional ME)
+#define ENCODER_FAST_MODE                1      ///< L0174: enable encoder fast mode. TestMethod 1 is enabled by setting to 1 and TestMethod 2 is enable by setting to 2. By default it is set to 1.
+#if !AVC_BASE || AVC_SYNTAX
+#define REF_IDX_MFM                      1      ///< L0336: motion vector mapping of inter-layer reference picture
+#endif
+
+#if REF_IDX_MFM
+#define REUSE_MVSCALE                    1      ///< using the base layer MV scaling function
+#define REUSE_BLKMAPPING                 1      ///< using the base layer get co-located block function
+#endif
+
+#else
+#define INTRA_BL                         0      ///< inter-layer texture prediction
+
+#if INTRA_BL
+#define INTRA_BL_DST4x4                  1      ///< L0067/L0204: DST4x4 for Intra BL
+#define NO_RESIDUAL_FLAG_FOR_BLPRED      1      ///< L0437: Root cbf for Intra_BL
+
+// Hooks
+#if !AVC_BASE || AVC_SYNTAX
+#define SVC_MVP                          1      ///< motion hook for merge mode as an example
+#if !AVC_SYNTAX
+#define SVC_BL_CAND_INTRA                0      ///< Intra Base Mode Prediction hook as an example 
+#endif
+#endif
+
+#if SVC_UPSAMPLING
+#define JCTVC_L0178                      1      ///< implementation of JCTVC-L0178 (code only supports right and bottom croppping offsets)
+#endif
+
+#endif
+#endif
+#else
+#define SYNTAX_OUTPUT                    0
+#endif
 
 //! \ingroup TLibCommon
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/NALread.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/NALread.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/NALread.cpp	(revision 54)
@@ -100,5 +100,9 @@
   nalu.m_nalUnitType = (NalUnitType) bs.read(6);  // nal_unit_type
   nalu.m_reservedZero6Bits = bs.read(6);       // nuh_reserved_zero_6bits
+#if SVC_EXTENSION
+  nalu.m_layerId = nalu.m_reservedZero6Bits;
+#else
   assert(nalu.m_reservedZero6Bits == 0);
+#endif
   nalu.m_temporalId = bs.read(3) - 1;             // nuh_temporal_id_plus1
 
Index: branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 54)
@@ -697,5 +697,12 @@
   }
   READ_FLAG( uiCode, "sps_temporal_mvp_enable_flag" );            pcSPS->setTMVPFlagsPresent(uiCode);
-
+#if REF_IDX_MFM
+  if(pcSPS->getLayerId() > 0)
+  {
+    READ_FLAG( uiCode, "sps_enh_mfm_enable_flag" );
+    pcSPS->setMFMEnabledFlag( uiCode ? true : false );
+    assert(pcSPS->getMFMEnabledFlag()); 
+  }
+#endif
   READ_FLAG( uiCode, "sps_strong_intra_smoothing_enable_flag" );  pcSPS->setUseStrongIntraSmoothing(uiCode);
 
@@ -1927,4 +1934,11 @@
 }
 
+#if INTRA_BL
+Void TDecCavlc::parseIntraBLFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth )
+{
+  assert(0);
+}
+#endif
+
 //! \}
 
